import 'package:flutter/cupertino.dart';

class GaragesalePostPageState {
  //表单的错误信息展示
  String? fieldErrorText;
  //表单的校验与数据
  final Map<String, Map<String, dynamic>> formData;

  // 标题
  final String? title;
  // 描述
  final String? description;

  //sale 类型选项
  final List<String> saleOptionsList = ["SALE1", "SALE2", "SALE3", "SALE4"];
  String? saleSelectedOption;

  //category 类型选项
  final List<String> categoryOptionsList = ["Category1", "Category2", "Category3", "Category4"];
  String? categorySelectedOption;

  // 选择的图片
  final List<String> imgList;

  GaragesalePostPageState({
    formData,
    required this.imgList,
    this.fieldErrorText,
    this.title,
    this.description,
    this.saleSelectedOption,
    this.categorySelectedOption,
  }): formData = formData ?? {
    'sale': {
      'value': '',
      'controller': TextEditingController(),
      'hintText': '',
      'focusNode': FocusNode(),
      'obsecure': false,
    },
    'category': {
      'value': '',
      'controller': TextEditingController(),
      'hintText': '',
      'focusNode': FocusNode(),
      'obsecure': false,
    },
    'title': {
      'value': '',
      'controller': TextEditingController(),
      'hintText': '',
      'focusNode': FocusNode(),
      'obsecure': false,
    },
    'description': {
      'value': '',
      'controller': TextEditingController(),
      'hintText': '',
      'focusNode': FocusNode(),
      'obsecure': false,
    },
  };

  GaragesalePostPageState copyWith({
    Map<String, Map<String, dynamic>>? formData,
    List<String>? imgList,
    String? fieldErrorText,
    String? saleSelectedOption,
    String? categorySelectedOption,
    String? title,
    String? description,
  }) {
    return GaragesalePostPageState(
      formData: formData ?? this.formData,
      title: title ?? this.title,
      description: description ?? this.description,
      imgList: imgList ?? this.imgList,
      saleSelectedOption: saleSelectedOption ?? this.saleSelectedOption,
      categorySelectedOption: categorySelectedOption ?? this.categorySelectedOption,
      fieldErrorText: fieldErrorText ?? this.fieldErrorText,
    );
  }

}